| Home | Libraries | People | FAQ | More

#### connect (5 of 8 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename SocketService,
        typename Iterator,
        typename ConnectCondition>
    Iterator connect(
        basic_socket< Protocol, SocketService > & s,
        Iterator begin,
        ConnectCondition connect_condition);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

begin

  An iterator pointing to the start of a sequence of endpoints.

connect_condition

  A function object that is called prior to each connection attempt. The signature of the function object must be:

      Iterator connect_condition(
          const boost::system::error_code& ec,
          Iterator next);

  The `ec` parameter contains the result from the most recent connect operation. Before the first connection attempt, `ec` is always set to indicate success. The `next` parameter is an iterator pointing to the next endpoint to be tried. The function object should return the next iterator, but is permitted to return a different iterator so that endpoints may be skipped. The implementation guarantees that the function object will never be called with the end iterator.

###### Return Value

On success, an iterator denoting the successfully connected endpoint. Otherwise, the end iterator.

###### Exceptions

boost::system::system_error

  Thrown on failure. If the sequence is empty, the associated `error_code` is `boost::asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Remarks

This overload assumes that a default constructed object of type `Iterator` represents the end of the sequence. This is a valid assumption for iterator types such as `boost::asio::ip::tcp::resolver::iterator`.

###### Example

The following connect condition function object can be used to output information about the individual connection attempts:

    struct my_connect_condition
    {
      template <typename Iterator>
      Iterator operator()(
          const boost::system::error_code& ec,
          Iterator next)
      {
        if (ec) std::cout << "Error: " << ec.message() << std::endl;
        std::cout << "Trying: " << next->endpoint() << std::endl;
        return next;
      }
    };

It would be used with the `boost::asio::connect` function as follows:

    tcp::resolver r(io_service);
    tcp::resolver::query q("host", "service");
    tcp::socket s(io_service);
    tcp::resolver::iterator i = boost::asio::connect(
        s, r.resolve(q), my_connect_condition());
    std::cout << "Connected to: " << i->endpoint() << std::endl;